--- /srv/web/ipfire/cgi-bin/dhcp.cgi.org	2019-04-13 13:32:01.000000000 +0200
+++ /srv/web/ipfire/cgi-bin/dhcp.cgi	2019-04-14 00:45:43.433156979 +0200
@@ -412,12 +412,16 @@
     }

     my $key = 0;
+    my $szc =  scalar(@current2);
     CHECK:foreach my $line (@current2) {
         my @temp = split(/\,/,$line);
         if($dhcpsettings{'KEY2'} ne $key) {
  	    # same MAC is OK on different subnets. This test is not complete because
 	    # if ip are not inside a known subnet, I don't warn.
 	    # Also it may be needed to put duplicate fixed lease in their right subnet definition..
+ 	    if ((lc($dhcpsettings{'FIX_MAC'}) eq lc($temp[0])) &&(lc($dhcpsettings{'FIX_ADDR'}) eq lc($temp[1]))) {
+ 	        last CHECK;
+        }
 	    foreach my $itf (@ITFs) {
 		my $scoped = &General::IpInSubnet($dhcpsettings{'FIX_ADDR'},
 						  $netsettings{"${itf}_NETADDRESS"},
@@ -442,11 +446,19 @@
 	$dhcpsettings{'FIX_FILENAME'} = &Header::cleanhtml($dhcpsettings{'FIX_FILENAME'});
 	$dhcpsettings{'FIX_ROOTPATH'} = &Header::cleanhtml($dhcpsettings{'FIX_ROOTPATH'});
 	if ($dhcpsettings{'KEY2'} eq '') { #add or edit ?
+	    if($key == $szc) { #add
+	        @current2[$key] = "$dhcpsettings{'FIX_MAC'},$dhcpsettings{'FIX_ADDR'},$dhcpsettings{'FIX_ENABLED'},$dhcpsettings{'FIX_NEXTADDR'},$dhcpsettings{'FIX_FILENAME'},$dhcpsettings{'FIX_ROOTPATH'},$dhcpsettings{'FIX_REMARK'}\n";
+	        # sort newly added/modified entry
+	        &sortcurrent2;
+	        &General::log($Lang::tr{'fixed ip lease added'});
+	        $dhcpsettings{'KEY2'} = '';
+        } else { #edit
 	    unshift (@current2, "$dhcpsettings{'FIX_MAC'},$dhcpsettings{'FIX_ADDR'},$dhcpsettings{'FIX_ENABLED'},$dhcpsettings{'FIX_NEXTADDR'},$dhcpsettings{'FIX_FILENAME'},$dhcpsettings{'FIX_ROOTPATH'},$dhcpsettings{'FIX_REMARK'}\n");
 	    &General::log($Lang::tr{'fixed ip lease added'});

 	    # Enter edit mode
 	    $dhcpsettings{'KEY2'} = 0;
+        }
 	} else {
 	    @current2[$dhcpsettings{'KEY2'}] = "$dhcpsettings{'FIX_MAC'},$dhcpsettings{'FIX_ADDR'},$dhcpsettings{'FIX_ENABLED'},$dhcpsettings{'FIX_NEXTADDR'},$dhcpsettings{'FIX_FILENAME'},$dhcpsettings{'FIX_ROOTPATH'},$dhcpsettings{'FIX_REMARK'}\n";
 	    $dhcpsettings{'KEY2'} = '';       # End edit mode
